  
#ifndef _linearmosaic_cmpt_h_
#define _linearmosaic_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/synthesis/linearmosaic_forward.h>

using namespace std;

namespace casac {
           


   class  linearmosaic  {
       public :


         ~linearmosaic();
         linearmosaic();

         bool defineoutputimage( int  nx=128,  int  ny=-1,  const variant & cellx= variant(),  const variant & celly= variant(),  const variant & imagecenter= variant(), const  string& outputimage=string(""), const  string& outputweight=string(""));

         bool setoutputimage(const  string& outputimage=string(""), const  string& outputweight=string(""),  int  imageweighttype=1,  int  weighttype=1);

         bool saultweightimage(const  string& outputimage=string(""), 
			  double fracpeak=0.1);

         bool setlinmostype(const  string& linmostype=string("optimal"));

         bool makemosaic( const variant & images= variant(),  const variant & weightimages= variant(),  int  imageweighttype=1,  int  weighttype=1);


      private :
#include <tools/synthesis/linearmosaic_private.h>
   }; 

 
}
#endif
