  
#ifndef _msplot_cmpt_h_
#define _msplot_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/ms/msplot_forward.h>

using namespace std;

namespace casac {
           


   class  msplot  {
       public :


         ~msplot();
         msplot();

         bool open(const  string& msname=string(""),  bool  dovel=false, const  string& restfreq=string(""), const  string& frame=string(""), const  string& doppler=string(""));

         bool clearplot( int  subplot=000);

         bool emperorsNewClose();

         bool reset();

         bool closeMS();

         bool close();

         bool done();

         bool plotoptions( int  subplot=111, const  string& plotsymbol=string(""), const  string& plotcolor=string(""), const  string& multicolor=string("none"), const  string& plotrange=string(""),  char  timeplot='o', 
			  double markersize=8.0, 
			  double linewidth=1.0,  bool  overplot=false,  bool  replacetopplot=false,  bool  removeoldpanels=true,  int  skipnrows=1,  int  averagenrows=1, const  string& extendflag=string(""), const  string& connect=string("none"),  bool  showflags=false, const  string& title=string(""), const  string& xlabel=string(""), const  string& ylabel=string(""), 
			  double fontsize=14.0, 
			  double windowsize=1.0, 
			  double aspectratio=1.0);

         bool summary( bool  selected=true);

         bool setdata(const  string& baseline=string(""), const  string& field=string(""), const  string& scan=string(""), const  string& uvrange=string(""), const  string& array=string(""), const  string& feed=string(""), const  string& spw=string(""), const  string& correlation=string(""), const  string& time=string(""));

         bool extendflag(const  string& extendcorr=string(""), const  string& extendchan=string(""), const  string& extendspw=string(""), const  string& extendant=string(""), const  string& extendtime=string(""));

         bool avedata(const  string& chanavemode=string("none"), const  string& corravemode=string("none"), const  string& datacolumn=string("DATA"), const  string& averagemode=string("vector"), const  string& averagechan=string("1"), const  string& averagetime=string("0"),  bool  averageflagged=false,  bool  averagescan=false,  bool  averagebl=false,  bool  averagearray=false,  bool  averagechanid=false,  bool  averagevel=false);

         bool plot(const  string& type=string(""), const  string& column=string(""), const  string& value=string(""),  const std::vector<std::string>& iteration=std::vector<string>(1, ""));

         bool checkplot(const  string& plottype=string(""), const  string& column=string("data"), const  string& value=string("amp"),  const std::vector<std::string>& iteration=std::vector<string>(1, ""));

         bool plotxy(const  string& x=string("uvdist"), const  string& y=string("data"), const  string& xcolumn=string("data"), const  string& ycolumn=string("data"), const  string& xvalue=string("amp"), const  string& yvalue=string("amp"),  const std::vector<std::string>& iteration=std::vector<string>(1, ""));

         bool checkplotxy(const  string& x=string("uvdist"), const  string& y=string("data"), const  string& xcolumn=string("data"), const  string& ycolumn=string("data"), const  string& xvalue=string("amp"), const  string& yvalue=string("amp"),  const std::vector<std::string>& iteration=std::vector<string>(1, ""));

         bool iterplotstart();

         bool iterplotnext();

         bool iterplotstop( bool  rmplotter=false);

         bool savefig(const  string& filename=string(""),  int  dpi=-1, const  string& orientation=string(""), const  string& papertype=string(""), const  string& facecolor=string(""), const  string& edgecolor=string(""));

         bool markregion( int  subplot=111,  const std::vector<double>& region=initialize_vector(1, (double)0.0));

         bool flagdata();

         bool unflagdata();

         bool clearflags();

         bool locatedata();

         bool saveflagversion(const  string& versionname=string(""), const  string& comment=string(""), const  string& merge=string("replace"));

         bool restoreflagversion( const std::vector<std::string>& versionname=std::vector<string>(1, ""), const  string& merge=string("replace"));

         bool deleteflagversion( const std::vector<std::string>& versionname=std::vector<string>(1, ""));

         bool getflagversionlist();


      private :
#include <tools/ms/msplot_private.h>
   }; 

 
}
#endif
