  
#ifndef _synthesisimager_cmpt_h_
#define _synthesisimager_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <synthesisimstore_cmpt.h>
#include <tools/synthesis/synthesisimager_forward.h>

using namespace std;

namespace casac {
           


   class  synthesisimager  {
       public :


         ~synthesisimager();
         synthesisimager();

         bool selectdata( const record& selpars=initialize_record("") );

         record* tuneselectdata();

         bool defineimage( const record& impars=initialize_record("") ,  const record& gridpars=initialize_record("") );

         bool setdata(const  string& msname=string(""), const  string& spw=string(""), const  string& freqbeg=string(""), const  string& freqend=string(""), const  string& freqframe=string("LSRK"), const  string& field=string(""), const  string& antenna=string(""), const  string& timestr=string(""), const  string& scan=string(""), const  string& obs=string(""), const  string& state=string(""), const  string& uvdist=string(""), const  string& taql=string(""),  bool  usescratch=false,  bool  readonly=false,  bool  incrmodel=false);

         bool setimage(const  string& imagename=string(""),  int  nx=128,  int  ny=-1,  const variant & cellx= variant(),  const variant & celly= variant(), const  string& stokes=string("I"),  const variant & phasecenter= variant(),  int  nchan=-1,  const variant & freqstart= variant(),  const variant & freqstep= variant(),  const variant & restfreq= variant(),  int  facets=1, const  string& ftmachine=string("gridft"),  int  ntaylorterms=1,  const variant & reffreq= variant(), const  string& projection=string("SIN"),  const variant & distance= variant(), const  string& freqframe=string("LSRK"),  bool  tracksource=false,  const variant & trackdir= variant(),  bool  overwrite=true,  float  padding=1.0,  bool  useautocorr=false,  bool  usedoubleprec=true,  int  wprojplanes=1, const  string& convfunc=string("SF"), const  string& startmodel=string(""),  bool  aterm=true,  bool  psterm=true,  bool  mterm=false,  bool  wbawp=true, const  string& cfcache=string(""),  bool  dopointing=false,  bool  dopbcorr=true,  bool  conjbeams=true,  float  computepastep=360.0,  float  rotatepastep=5.0);

         bool setweighting(const  string& type=string("natural"), const  string& rmode=string("norm"),  const variant & noise= variant(), 
			  double robust=0.0,  const variant & fieldofview= variant(),  int  npixels=0,  bool  multifield=false,  const std::vector<std::string>& uvtaper=std::vector<string>(1, ""));

         bool makepsf();

         bool predictmodel();

         bool drygridding( const std::vector<std::string>& cflist=std::vector<string>(1, ""));

         bool fillcfcache( const std::vector<std::string>& cflist=std::vector<string>(1, ""), const  string& ftmname=string(""), const  string& cfcpath=string(""),  bool  pstermon=
	false
      ,  bool  atermon=
	true
      ,  bool  conjbeams=
	true
      );

         bool reloadcfcache();

         bool executemajorcycle( const record& controls=initialize_record("") );

         bool makepb();

         
                                      casac::synthesisimstore* getimstore( int  id=0);

         record* getcsys();

         int updatenchan();

         bool getweightdensity();

         bool setweightdensity();

         bool done();


      private :
#include <tools/synthesis/synthesisimager_private.h>
   }; 

 
}
#endif
